Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/CorePlugin.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/CorePlugin.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/CorePlugin.cs	(revision 4107)
@@ -27,14 +27,15 @@
 
 namespace HeuristicLab.Hive.Client.Core {
-  [Plugin("HeuristicLab.Hive.Client.Core-3.3")]
+  [Plugin("HeuristicLab.Hive.Client.Core", "3.3")]
   [PluginFile("HeuristicLab.Hive.Client.Core-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Core-3.3")]
-  [PluginDependency("HeuristicLab.DataAccess-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Client.Common-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Client.Communication-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Client.ExecutionEngine-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Contracts-3.3")]
-  [PluginDependency("HeuristicLab.Hive.JobBase-3.3")]
-  [PluginDependency("HeuristicLab.Tracing", "3.3.0")]
+  [PluginDependency("HeuristicLab.Calendar", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.DataAccess", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Client.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Client.Communication", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Client.ExecutionEngine", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Contracts", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.JobBase", "3.3")]
+  [PluginDependency("HeuristicLab.Tracing", "3.3")]
   public class CorePlugin: PluginBase {
   }
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/HeuristicLab.Hive.Client.Core-3.3.csproj
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/HeuristicLab.Hive.Client.Core-3.3.csproj	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/HeuristicLab.Hive.Client.Core-3.3.csproj	(revision 4107)
@@ -140,4 +140,12 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Calendar\3.3\HeuristicLab.Calendar-3.3.csproj">
+      <Project>{D17A4D6A-4CAA-4470-8A19-F42463C021FD}</Project>
+      <Name>HeuristicLab.Calendar-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.DataAccess\3.3\HeuristicLab.DataAccess-3.3.csproj">
+      <Project>{9076697B-C151-46CD-95BC-1D059492B478}</Project>
+      <Name>HeuristicLab.DataAccess-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Hive.Client.Common\3.3\HeuristicLab.Hive.Client.Common-3.3.csproj">
       <Project>{89F4BC52-C174-481E-9BD2-3814171020E8}</Project>
@@ -148,7 +156,15 @@
       <Name>HeuristicLab.Hive.Client.Communication-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.Client.ExecutionEngine\3.3\HeuristicLab.Hive.Client.ExecutionEngine-3.3.csproj">
+      <Project>{1605256A-1CB3-44AB-AAFF-577093EE5789}</Project>
+      <Name>HeuristicLab.Hive.Client.ExecutionEngine-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Hive.Contracts\3.3\HeuristicLab.Hive.Contracts-3.3.csproj">
       <Project>{134F93D7-E7C8-4ECD-9923-7F63259A60D8}</Project>
       <Name>HeuristicLab.Hive.Contracts-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.JobBase\3.3\HeuristicLab.Hive.JobBase-3.3.csproj">
+      <Project>{21187322-52DD-4243-80A4-A85F0263E63B}</Project>
+      <Name>HeuristicLab.Hive.JobBase-3.3</Name>
     </ProjectReference>
   </ItemGroup>
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/Properties/AssemblyInfo.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Core/3.3/Properties/AssemblyInfo.cs	(revision 4107)
@@ -57,5 +57,5 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.4078")]
-[assembly: AssemblyFileVersion("3.3.0.4078")]
-[assembly: AssemblyBuildDate("2010/07/22 16:16:39")]
+[assembly: AssemblyVersion("3.3.0.4091")]
+[assembly: AssemblyFileVersion("3.3.0.4091")]
+[assembly: AssemblyBuildDate("2010/07/26 18:07:12")]
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/ExecutionEnginePlugin.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/ExecutionEnginePlugin.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/ExecutionEnginePlugin.cs	(revision 4107)
@@ -27,11 +27,11 @@
 
 namespace HeuristicLab.Hive.Client.ExecutionEngine {
-  [Plugin("HeuristicLab.Hive.Client.ExecutionEngine-3.3")]
+  [Plugin("HeuristicLab.Hive.Client.ExecutionEngine", "3.3")]
   [PluginFile("HeuristicLab.Hive.Client.ExecutionEngine-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Core-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Client.Common-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Client.Communication-3.3")]
-  [PluginDependency("HeuristicLab.Hive.Contracts-3.3")]
-  [PluginDependency("HeuristicLab.Hive.JobBase-3.3")] 
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Client.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Client.Communication", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.Contracts", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.JobBase", "3.3")] 
   public class ExecutionEnginePlugin: PluginBase {
   }
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/Executor.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/Executor.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/Executor.cs	(revision 4107)
@@ -25,7 +25,11 @@
 using HeuristicLab.Hive.JobBase;
 using HeuristicLab.Persistence.Core;
+using HeuristicLab.Common;
+using System.Xml.Serialization;
+using HeuristicLab.Persistence.Default.Xml;
+using System.IO;
 
 namespace HeuristicLab.Hive.Client.ExecutionEngine {
-  public class Executor: MarshalByRefObject, IDisposable {
+  public class Executor : MarshalByRefObject, IDisposable {
     public Guid JobId { get; set; }
     public IJob Job { get; set; }
@@ -51,9 +55,11 @@
     public void Start(byte[] serializedJob) {
       CreationTime = DateTime.Now;
-      throw new NotImplementedException("TODO[chn] use persistency-3.3");
+      //throw new NotImplementedException("TODO[chn] use persistency-3.3");
       // Job = (IJob)PersistenceManager.RestoreFromGZip(serializedJob);
-      
+
+      Job = XmlParser.Deserialize<IJob>(new MemoryStream(serializedJob));
+
       //debug
-      Job = new TestJob();
+      //Job = new TestJob();
 
       Job.JobStopped += new EventHandler(Job_JobStopped);
@@ -72,5 +78,5 @@
     public void Abort() {
       CurrentMessage = MessageContainer.MessageType.AbortJob;
-      Job.Stop();      
+      Job.Stop();
     }
 
@@ -80,7 +86,7 @@
         JobIsFinished = true;
       } else if (CurrentMessage == MessageContainer.MessageType.RequestSnapshot) {
-          Queue.AddMessage(new MessageContainer(MessageContainer.MessageType.SnapshotReady, JobId));
+        Queue.AddMessage(new MessageContainer(MessageContainer.MessageType.SnapshotReady, JobId));
       } else if (CurrentMessage == MessageContainer.MessageType.AbortJob) {
-          Queue.AddMessage(new MessageContainer(MessageContainer.MessageType.JobAborted, JobId));
+        Queue.AddMessage(new MessageContainer(MessageContainer.MessageType.JobAborted, JobId));
       }
     }
@@ -94,5 +100,5 @@
         CurrentMessage = MessageContainer.MessageType.NoMessage;
         // Pack the whole job inside an xml document
-        byte[] job = SerializeJobObject();        
+        byte[] job = SerializeJobObject();
         // Restart the job
         // Return the Snapshot
@@ -106,9 +112,8 @@
         throw new InvalidStateException("Job is still running");
       } else {
-        byte[] jobArr = SerializeJobObject();        
+        byte[] jobArr = SerializeJobObject();
         return jobArr;
       }
-    }    
-
+    }
 
     public void RequestSnapshot() {
@@ -118,11 +123,11 @@
 
     private byte[] SerializeJobObject() {
-      throw new NotImplementedException("TODO[chn] use persistency-3.3");
-      return null; // PersistenceManager.SaveToGZip(Job);
+      MemoryStream stream = new MemoryStream();
+      XmlGenerator.Serialize(Job, stream);
+      return stream.ToArray();
     }
 
     private void RestoreJobObject(byte[] sjob) {
-      throw new NotImplementedException("TODO[chn] use persistency-3.3");
-      //Job = (IJob)PersistenceManager.RestoreFromGZip(sjob);
+      Job = XmlParser.Deserialize<IJob>(new MemoryStream(sjob));
     }
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/HeuristicLab.Hive.Client.ExecutionEngine-3.3.csproj
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/HeuristicLab.Hive.Client.ExecutionEngine-3.3.csproj	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.ExecutionEngine/3.3/HeuristicLab.Hive.Client.ExecutionEngine-3.3.csproj	(revision 4107)
@@ -76,4 +76,7 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Persistence-3.3">
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Persistence-3.3.dll</HintPath>
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/StreamedObject.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/StreamedObject.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/StreamedObject.cs	(revision 4107)
@@ -18,6 +18,5 @@
       this.encapsulatedObject = encapsulatedObject;
 
-      BinaryFormatter formatter =
-        new BinaryFormatter();
+      BinaryFormatter formatter = new BinaryFormatter();
       formatter.Serialize(this.stream, this.encapsulatedObject);
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HeuristicLab.Hive.Engine-3.3.csproj
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HeuristicLab.Hive.Engine-3.3.csproj	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HeuristicLab.Hive.Engine-3.3.csproj	(revision 4107)
@@ -100,4 +100,5 @@
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Data-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HiveEngine.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HiveEngine.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/HiveEngine.cs	(revision 4107)
@@ -28,4 +28,5 @@
 using System.Xml;
 using System.IO.Compression;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Hive.JobBase;
@@ -35,4 +36,6 @@
 using HeuristicLab.Hive.Contracts.BusinessObjects;
 using HeuristicLab.Tracing;
+using HeuristicLab.Persistence.Default.Xml;
+using System.Reflection;
 
 namespace HeuristicLab.Hive.Engine {
@@ -49,4 +52,5 @@
     private object locker = new object();
     private volatile bool abortRequested;
+    private ThreadPriority priority;
 
     public string HiveServerUrl { get; set; }
@@ -55,4 +59,9 @@
 
     public HiveEngine() {
+      // <debug>
+      HiveServerUrl = "net.tcp://10.42.1.153:9000/ExecutionEngine/ExecutionEngineFacade";
+      RessourceIds = "MyGroup";
+      // </debug>
+
       job = new Job();
       abortRequested = false;
@@ -73,6 +82,6 @@
 
     public ThreadPriority Priority {
-      get { return this.Priority; }
-      set { this.Priority = value; }
+      get { return this.priority; }
+      set { this.priority = value; }
     }
 
@@ -148,6 +157,5 @@
             if (response.Success && response.Obj != null && response.StatusMessage != ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE) {
               Logger.Debug("HiveEngine: Results-polling - Got result!");
-              throw new NotImplementedException("TODO[chn]use persistency-3.3");
-              //restoredJob = (Job)PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobData);
+              restoredJob = XmlParser.Deserialize<Job>(new MemoryStream(response.Obj.SerializedJobData));
               Logger.Debug("HiveEngine: Results-polling - IsSnapshotResult: " + (restoredJob.Progress < 1.0));
             }
@@ -167,52 +175,91 @@
 
     private HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob CreateJobObj() {
-      HeuristicLab.Hive.Contracts.BusinessObjects.JobDto jobObj =
-        new HeuristicLab.Hive.Contracts.BusinessObjects.JobDto();
-
-
-      throw new NotImplementedException("TODO[chn]use persistency-3.3");
-
-      //MemoryStream memStream = new MemoryStream();
-      //GZipStream stream = new GZipStream(memStream, CompressionMode.Compress, true);
-      //XmlDocument document = PersistenceManager.CreateXmlDocument();
-      //Dictionary<Guid, IStorable> dictionary = new Dictionary<Guid, IStorable>();
-      //XmlNode rootNode = document.CreateElement("Root");
-      //document.AppendChild(rootNode);
-      //rootNode.AppendChild(PersistenceManager.Persist(job, document, dictionary));
-      //document.Save(stream);
-      //stream.Close();
-
-      //HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob executableJobObj =
-      //  new HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob();
-      //executableJobObj.JobInfo = jobObj;
-      //executableJobObj.SerializedJobData = memStream.ToArray();
-
-      //List<IPluginDescription> plugins = new List<IPluginDescription>();
-
-      //foreach (IStorable storeable in dictionary.Values) {
-      //  IPluginDescription pluginInfo = ApplicationManager.Manager.GetDeclaringPlugin(storeable.GetType());
-      //  if (!plugins.Contains(pluginInfo)) {
-      //    plugins.Add(pluginInfo);
-      //    foreach (var dependency in pluginInfo.Dependencies) {
-      //      if (!plugins.Contains(dependency)) plugins.Add(dependency);
-      //    }
-      //  }
-      //}
-
-      //List<HivePluginInfoDto> pluginsNeeded =
-      //  new List<HivePluginInfoDto>();
-      //foreach (IPluginDescription uniquePlugin in plugins) {
-      //  HivePluginInfoDto pluginInfo =
-      //    new HivePluginInfoDto();
-      //  pluginInfo.Name = uniquePlugin.Name;
-      //  pluginInfo.Version = uniquePlugin.Version;
-      //  pluginInfo.BuildDate = uniquePlugin.BuildDate;
-      //  pluginsNeeded.Add(pluginInfo);
-      //}
-
-      //jobObj.CoresNeeded = 1;
-      //jobObj.PluginsNeeded = pluginsNeeded;
-      //jobObj.State = HeuristicLab.Hive.Contracts.BusinessObjects.State.offline;
-      //return executableJobObj;
+      HeuristicLab.Hive.Contracts.BusinessObjects.JobDto jobObj = new HeuristicLab.Hive.Contracts.BusinessObjects.JobDto();
+
+      // create xml document with <Root> as root-node and the persisted job as child
+      MemoryStream memStream = new MemoryStream();
+      XmlGenerator.Serialize(job, memStream);
+
+      // convert memStream to byte-array
+      HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob executableJobObj = new HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob();
+      executableJobObj.JobInfo = jobObj;
+      executableJobObj.SerializedJobData = memStream.ToArray();
+
+      // find out which which plugins are needed to recreate the type
+      List<HivePluginInfoDto> pluginsNeeded = (
+        from p in GetDeclaringPlugins(job.GetType())
+        select new HivePluginInfoDto() {
+          Name = p.Name,
+          Version = p.Version,
+          BuildDate = p.BuildDate,
+        }).ToList();
+
+      jobObj.CoresNeeded = 1;
+      jobObj.PluginsNeeded = pluginsNeeded;
+      jobObj.State = HeuristicLab.Hive.Contracts.BusinessObjects.State.offline;
+      return executableJobObj;
+    }
+
+    /// <summary>
+    /// Returns a list of plugins in which the type itself and all members 
+    /// of the type are declared. Objectgraph is searched recursively.
+    /// </summary>
+    private IEnumerable<IPluginDescription> GetDeclaringPlugins(Type type) {
+      HashSet<Type> types = new HashSet<Type>();
+      FindTypes(type, types, "HeuristicLab.");
+      IEnumerable<IPluginDescription> plugins = from t in types
+                                                select ApplicationManager.Manager.GetDeclaringPlugin(t);
+      return plugins;
+    }
+
+    /// <summary>
+    /// Recursively finds all types used in type which are in a namespace which starts with namespaceStart
+    /// </summary>
+    /// <param name="type">the type to be searched</param>
+    /// <param name="types">found types will be stored there, needed in order to avoid duplicates</param>
+    /// <param name="namespaceStart">only types from namespaces which start with this will be searched and added</param>
+    private void FindTypes(Type type, HashSet<Type> types, string namespaceStart) {
+
+      // search is not performed on attributes
+
+      if (!types.Contains(type) && type.Namespace.StartsWith(namespaceStart)) {
+        types.Add(type);
+
+        // interfaces
+        foreach (Type t in type.GetInterfaces()) {
+          FindTypes(t, types, namespaceStart);
+        }
+
+        // events
+        foreach (EventInfo info in type.GetEvents()) {
+          FindTypes(info.EventHandlerType, types, namespaceStart);
+          FindTypes(info.DeclaringType, types, namespaceStart);
+        }
+
+        // properties
+        foreach (PropertyInfo info in type.GetProperties()) {
+          FindTypes(info.PropertyType, types, namespaceStart);
+        }
+
+        // fields
+        foreach (FieldInfo info in type.GetFields()) {
+          FindTypes(info.FieldType, types, namespaceStart);
+        }
+
+        // constructors : maybe constructors them out (?)
+        foreach (ConstructorInfo info in type.GetConstructors()) {
+          foreach (ParameterInfo paramInfo in info.GetParameters()) {
+            FindTypes(paramInfo.ParameterType, types, namespaceStart);
+          }
+        }
+
+        // methods
+        foreach (MethodInfo info in type.GetMethods()) {
+          foreach (ParameterInfo paramInfo in info.GetParameters()) {
+            FindTypes(paramInfo.ParameterType, types, namespaceStart);
+          }
+          FindTypes(info.ReturnType, types, namespaceStart);
+        }
+      }
     }
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/Job.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/Job.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Engine/3.3/Job.cs	(revision 4107)
@@ -29,4 +29,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Hive.Engine {
@@ -34,5 +35,7 @@
   /// Represents a job that wraps an engine that should be executed in the hive.
   /// </summary>
+  [StorableClass]
   public class Job : IJob {
+    [Storable]
     private IEngine engine;
     public IEngine Engine {
@@ -79,4 +82,5 @@
     public event EventHandler JobFailed;
 
+    [Storable]
     public long JobId {
       get;
@@ -84,4 +88,5 @@
     }
 
+    [Storable]
     private double progress;
     public double Progress {
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HeuristicLab.Hive.Server.Console-3.3.csproj
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HeuristicLab.Hive.Server.Console-3.3.csproj	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HeuristicLab.Hive.Server.Console-3.3.csproj	(revision 4107)
@@ -81,4 +81,7 @@
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/JobDataFetcher.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/JobDataFetcher.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/JobDataFetcher.cs	(revision 4107)
@@ -67,5 +67,7 @@
     }
 
-    private void DoUpdateRun() {      
+    private void DoUpdateRun() {
+      // [chn] Exception occured here: PollStates enumeration changed!
+      // todo: make access to PollStates thread-safe!
       foreach (State stat in PollStates) {
         ResponseList<JobDto> resList = ServiceLocator.GetJobManager().GetAllJobsWithFilter(stat, CurrentPage * NrOfEntriesOnPage,
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4107)
@@ -86,7 +86,5 @@
 
     public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
-      using (contextFactory.GetContext()) {
-        return clientCommunicator.SendPlugins(pluginList);      
-      }
+      return clientCommunicator.SendPlugins(pluginList);      
     }
 
@@ -122,5 +120,5 @@
         ResponseJob job = null;
 
-        job = this.SendJob(clientId);
+        job = ServiceLocator.GetClientCommunicator().SendJob(clientId);
 
         //first send response
@@ -147,7 +145,5 @@
 
     public Stream SendStreamedPlugins(List<HivePluginInfoDto> pluginList) {
-      using (contextFactory.GetContext()) {
-        return new StreamedObject<ResponsePlugin>(this.SendPlugins(pluginList));
-      }
+      return new StreamedObject<ResponsePlugin>(this.SendPlugins(pluginList));
     }
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4107)
@@ -235,6 +235,5 @@
 
     //Requested means: there MUST be a job result which gets sent back
-    public ResponseObject<SerializedJob>
-      GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
+    public ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
       ResponseObject<SerializedJob> response =
         new ResponseObject<SerializedJob>();
@@ -270,8 +269,6 @@
     }
 
-
     public Response RequestSnapshot(Guid jobId) {
       Response response = new Response();
-
 
       JobDto job = DaoLocator.JobDao.FindById(jobId);
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/LifecycleManager.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/LifecycleManager.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/LifecycleManager.cs	(revision 4107)
@@ -53,20 +53,26 @@
 
     public void Init() {
-      timer.Interval = new TimeSpan(0, 0, 10).TotalMilliseconds; // TODO: global constant needed
-      timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
-      timer.Start();
+      using (ServiceLocator.GetContextFactory().GetContext()) {
+        timer.Interval = new TimeSpan(0, 0, 10).TotalMilliseconds; // TODO: global constant needed
+        timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
+        timer.Start();
 
-      if (OnStartup != null)
-        OnStartup(this, null);
+        if (OnStartup != null)
+          OnStartup(this, null);
+      }
     }
 
     void timer_Elapsed(object sender, ElapsedEventArgs e) {
-      if (OnServerHeartbeat != null)
-        OnServerHeartbeat(this, null);
+      using (ServiceLocator.GetContextFactory().GetContext()) {
+        if (OnServerHeartbeat != null)
+          OnServerHeartbeat(this, null);
+      }
     }
 
     public void Shutdown() {
-      if (OnShutdown != null)
-        OnShutdown(this, null);
+      using (ServiceLocator.GetContextFactory().GetContext()) {
+        if (OnShutdown != null)
+          OnShutdown(this, null);
+      }
     }
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Properties/AssemblyInfo.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Properties/AssemblyInfo.cs	(revision 4107)
@@ -55,5 +55,5 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.4092")]
-[assembly: AssemblyFileVersion("3.3.0.4092")]
-[assembly: AssemblyBuildDate("2010/07/26 09:32:07")]
+[assembly: AssemblyVersion("3.3.0.4105")]
+[assembly: AssemblyFileVersion("3.3.0.4105")]
+[assembly: AssemblyBuildDate("2010/07/26 18:07:14")]
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HiveServerPlugin.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HiveServerPlugin.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HiveServerPlugin.cs	(revision 4107)
@@ -34,5 +34,4 @@
   [PluginDependency("HeuristicLab.Hive.Contracts", "3.3")]
   [PluginDependency("HeuristicLab.Hive.Server.LINQDataAccess", "3.3")]
-  //[PluginDependency("HeuristicLab.SpringNET", "1.3.0.0")]
   [PluginDependency("HeuristicLab.Tracing", "3.3")]
   public class HiveServerPlugin : PluginBase {
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.cs	(revision 4107)
@@ -15,4 +15,5 @@
           InitializeComponent();
           this.Visible = false;
+          this.Hide();
 
           Uri uri;
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/CustomPostBuild.cmd
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/CustomPostBuild.cmd	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/CustomPostBuild.cmd	(revision 4107)
@@ -1,7 +1,7 @@
 set target=C:\Programme\HeuristicLab 3.3
 
-copy "HeuristicLab 3.3.exe" "%target%"
+;copy "HeuristicLab 3.3.exe" "%target%"
 copy "HeuristicLab 3.3.exe.config" "%target%"
-copy HeuristicLab.PluginInfrastructure-3.3.dll "%target%"
+;copy HeuristicLab.PluginInfrastructure-3.3.dll "%target%"
 
 FOR /F "skip=1 tokens=1-2 delims=: usebackq" %%G IN ("%ProjectDir%\Files.txt") DO copy "%SolutionDir%\%%G\%Outdir%\%%H" "%target%" >nul
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/MergeConfigs.cmd
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/MergeConfigs.cmd	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/MergeConfigs.cmd	(revision 4107)
@@ -1,3 +1,4 @@
 ConfigMerger "%SolutionDir%HeuristicLab.Hive.Server\3.3\app.config" "HeuristicLab.Hive-3.3.dll.config"
+ConfigMerger "%SolutionDir%HeuristicLab.Hive.Client.Core\3.3\app.config" "HeuristicLab.Hive-3.3.dll.config"
 
 ConfigMerger "HeuristicLab.Hive-3.3.dll.config" "HeuristicLab 3.3.exe.config"
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/Properties/AssemblyInfo.cs	(revision 4105)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/Properties/AssemblyInfo.cs	(revision 4107)
@@ -51,4 +51,4 @@
 //      Revision
 //
-[assembly: AssemblyVersion("3.3.0.4092")]
-[assembly: AssemblyFileVersion("3.3.0.4092")]
+[assembly: AssemblyVersion("3.3.0.4105")]
+[assembly: AssemblyFileVersion("3.3.0.4105")]
